global function PingOverlay_Init

void function PingOverlay_Init()
{
    thread pingOverlayLoop()
}

void function pingOverlayLoop()
{
    WaitFrame()

    var pingOverlay = RuiCreate
    (
        $"ui/cockpit_console_text_top_left.rpak",
        clGlobal.topoCockpitHudPermanent,
        RUI_DRAW_COCKPIT,
        -1
    )
    RuiSetInt(pingOverlay, "maxLines", 1)
    RuiSetInt(pingOverlay, "lineNum", 1)
    RuiSetString(pingOverlay, "msgText", "...")
    RuiSetFloat(pingOverlay, "thicken", 0.0)
    RuiSetFloat(pingOverlay, "msgFontSize", GetConVarFloat("pingOverlay_size"))
    RuiSetFloat2
    (
        pingOverlay,
        "msgPos",
        Vector
        (
            GetConVarFloat("pingOverlay_positionX"),
            GetConVarFloat("pingOverlay_positionY"),
            0.0
        )
    )
    RuiSetFloat3(
        pingOverlay,
        "msgColor",
        Vector
        (
            GetConVarFloat("pingOverlay_colorChannelRed"),
            GetConVarFloat("pingOverlay_colorChannelGreen"),
            GetConVarFloat("pingOverlay_colorChannelBlue")
        )
    )
    RuiSetFloat(pingOverlay, "msgAlpha", GetConVarFloat("pingOverlay_alpha"))

    float refreshTime = GetConVarFloat("pingOverlay_refreshTime")
    bool isDynamicOverlay = GetConVarBool("pingOverlay_dynamic")

    while(true)
    {
        wait refreshTime
        WaitFrame()

        int ping = MyPing()

        string pingText = "Ping: " + format("%3i", ping)
        if(ping > 2000)
        {
            pingText += " 0_0"
        }
        RuiSetString(pingOverlay, "msgText", pingText)

        if(isDynamicOverlay)
        {
            vector textColor = <0.2, 0.6, 0.3>
            if(ping > 50)
            {
                if(ping < 100)
                {
                    textColor = <0.4, 1.0, 0.1>
                }
                else if(ping < 150)
                {
                    textColor = <1.0, 1.0, 0.5>
                }
                else if(ping < 200)
                {
                    textColor = <1.0, 0.4, 0.1>
                }
                else if(ping < 1000)
                {
                    textColor = <1.0, 0.0, 0.0>
                }
                else
                {
                    textColor = <1.0, 0.0, 1.0>
                }
            }
            RuiSetFloat3(pingOverlay, "msgColor", textColor)
        }
    }
}
